#include <fstream>
#include <algorithm>
#include <math.h>
#include <vector>
using namespace std;

ifstream cin("dat17.txt");
ofstream cout("ans17.txt");

vector <int> primeNumbers;
long long n, i, answer;
int *productComposition;
long long minAns;

bool isPrime(int number)
{
	int i;
	for (i = 2; i*i <= number; i++)
	{
		if (number%i == 0)
		{
			return false;
		}
	}
	return true;
}

void nextProducts(unsigned long long product, int productCompositionPosition, long long numberOfDividers)
{

	for (; productComposition[productCompositionPosition - 1] > productComposition[productCompositionPosition];)
	{
		productComposition[productCompositionPosition]++;
		numberOfDividers = numberOfDividers / productComposition[productCompositionPosition] * (productComposition[productCompositionPosition] + 1);
		product *= primeNumbers[productCompositionPosition - 1];
		if (product >= n)
		{
			break;
		}

		if (answer < numberOfDividers)
		{
			answer = numberOfDividers;

			minAns = product;
		}

		if (product*primeNumbers[productCompositionPosition] < n)
		{
			nextProducts(product, productCompositionPosition + 1, numberOfDividers);
		}
	}
	productComposition[productCompositionPosition] = 0;
}

int main()
{
	answer = 1;
	cin >> n;

	//lets find all necessary prime numbers
	unsigned long long timeN = 1;
	for (i = 2; timeN < n; i++)
	{
		if (isPrime(i))
		{
			timeN *= i;
			primeNumbers.push_back(i);
		}
	}

	// 1 = (1^BIG) * (2^0) * (3^0) * (5^0) * (7^0)...
	productComposition = new int[primeNumbers.size() + 1];
	productComposition[0] = log2(n) + 1;
	for (i = 1; i <= primeNumbers.size(); i++)
	{
		productComposition[i] = 0;
	}

	//main search
	nextProducts(1, 1, 1);

	//lets cout answer
	cout << answer << "\n" << minAns;

	return 0;
}